﻿-- Author      : Guy
-- Create Date : 2/9/2012 10:22:11 PM
-- Ability tracker module for Perception

local Perception = Perception
local AbilityMod = {}
local frame, events = CreateFrame("Frame"), {}
local epsilon = 0.000001
local streamtype = "abilities"
local GetTime = GetTime

function events:UNIT_SPELLCAST_SUCCEEDED(...)
		local unit, _, _, _, spellid = ...
		local name = UnitName(unit)		
		if Perception:IsRecording(name, streamtype) then
			local p, m = UnitPower(unit), UnitPowerMax(unit)
			local v = p / (m+epsilon) * 100
			local spell = GetSpellInfo(spellid)
			Perception:AddStoryPoint(name, streamtype, GetTime(), v, spellid, name.." casts "..spell)
		end
end

frame:SetScript("OnEvent", function(self, event, ...)		
	  events[event](self, ...);
	end);

for k, v in pairs(events) do	  	
	frame:RegisterEvent(k);
end

function AbilityMod:NewPlayer(name)
	Perception:RegisterStream(name, streamtype, nil, nil, "story") -- no function to call here
end

--time to register this module
Perception:RegisterModule("Abilities", AbilityMod)