﻿-- Author      : Arclight
-- Create Date : 2/9/2012 9:12:01 PM
-- Power tracker module for Perception

local Perception = Perception
local PowerMod = {}
local epsilon = 0.00000001
local PowerTypes = {
	[0] = "mana", 
	[1] = "rage", 
	[2] = "focus", 
	[3] = "energy", 
	[4] = "happiness", 
	[5] = "runes", 
	[6] = "runic power", 
	[7] = "soul shards", 
	[8] = "eclipse", 
	[9] = "holy power"};
local PowerTypeBack = {
	["mana"] = 0,
	["rage"] = 1,
	["focus"] = 2,
	["energy"] = 3,
	["happiness"] = 4,
	["runes"] = 5,
	["runic power"] = 6,
	["soul shards"] = 7,
	["eclipse"] = 8,
	["holy power"] = 9};

local function Capture(stream, player, streamtype, time)
	local t = PowerTypeBack[streamtype]
	local v = UnitPower(player, t)
	local m = UnitPowerMax(player, t)
	Perception:AddDataPoint(player, streamtype, time, v / (m+epsilon) * 100)
	--tinsert(stream.Raw, {time, v / (m+epsilon) * 100})	
end

function PowerMod:NewPlayer(name)
	local powertype = PowerTypes[UnitPowerType(name)]
	Perception:RegisterStream(name, powertype, Capture)
end

--time to register this module
Perception:RegisterModule("Power", PowerMod)